//  File:  expr.g  -  from An Intro To ANTLR
//============================================

grammar expr2;

expr2
    :	expr  { System.out.println($expr.value); }
    ;

expr returns [int value]
    :   e=mexpr          { $value =  $e.value; }
        ( PLUS  e=mexpr  { $value += $e.value; }
        | MINUS e=mexpr  { $value -= $e.value; } 
        )*
    ;

mexpr returns [int value]
    :   e=atom { $value = $e.value; } ( STAR e=atom  { $value *= $e.value; } )*
    ;

atom returns [int value]
    :   INT  { $value = Integer.parseInt($INT.text); }
    |   LPAREN expr RPAREN  { $value = $expr.value; }
    ;

LPAREN:  '(' ;
RPAREN:  ')' ;
PLUS  :  '+' ;
MINUS :  '-' ;
STAR  :  '*' ;
INT   :  ('0'..'9')+ ;
WS	:  (' ' | '\t' | '\r' | '\n')+ { $channel=HIDDEN; }
	;

//============================================
